In the computer world, use restricted resource you have to generate maximum benefit is what we always want to pursue.

For now, suppose you are a dominator of m 0s and n 1s respectively. On the other hand, there is an array with strings consisting of only 0s and 1s.

Now your task is to find the maximum number of strings that you can form with given m 0s and n 1s. Each 0 and 1 can be used at most once.

Note:

  1. The given numbers of 0s and 1s will both not exceed 100
  2. The size of given string array won’t exceed 600.

Example 1:

1
2
3
4
Input: Array = {"10", "0001", "111001", "1", "0"}, m = 5, n = 3
Output: 4
Explanation: This are totally 4 strings can be formed by the using of 5 0s and 3 1s, which are “10,”0001”,”1”,”0”

Example 2:

1
2
3
4
Input: Array = {"10", "0", "1"}, m = 1, n = 1
Output: 2
Explanation: You could form "10", but then you'd have nothing left. Better form "0" and "1".

思路

The problem is really a knapsack-ish problem, so I knew DP was the way to go. In this problem, we have two knapsacks, one with capacity m and another with capacity n. The ‘weight’ of each item is the number of ones and zeroes in it. And the ‘value’ of each item is exactly one, since we just want to maximize the number of items. So for each item, i.e. s, we calculate its weight first and use DP for the rest. If you are unfamiliar with knapsack, maybe reading this will help a little bit.

dp(i)(j) = the max number of strings that can be formed with i 0’s and j 1’s from the first few strings up to the current string s Catch: have to go from bottom right to top left

Why? If a cell in the memo is updated(because s is selected), we should be adding 1 to dp[i][j] from the previous iteration (when we were not considering s)

If we go from top left to bottom right, we would be using results from this iteration => overcounting

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
public class Solution {
public int findMaxForm(String[] strs, int m, int n) {
int[][] dp = new int[m+1][n+1];
for(int i = 0; i < strs.length; i++){
int zeros = 0;
int ones = 0;
for (int j = 0; j < strs[i].length(); j++){
if(strs[i].charAt(j) == '0'){
zeros++;
}
else{
ones++;
}
}
for (int j = m; j >= zeros; j--){
for(int k = n; k >= ones; k--){
dp[j][k] = Math.max(dp[j-zeros][k-ones] + 1, dp[j][k]);
}
}
// for (int j = 0; j <= m; j++){
// for(int k = 0; k <= n; k++){
// System.out.print(dp[j][k] + " ");
// }
// System.out.println();
// }
}
return dp[m][n];
}
}

参考资料:https://discuss.leetcode.com/topic/71438/c-dp-solution-with-comments/4